/*
  Simple module for VirtuaWin - Virtual Desktop Manager (virtuawin.sourceforge.net)
  Just switch to the first desktop after unlocking workstation.
*/

#include <windows.h>
#include <tchar.h>
#include <Wtsapi32.h>
#include <winuser.h>
#include "Messages.h"

int initialised=0 ;
HWND vwHandle;                 /* Handle to VirtuaWin */
HWND g_hWnd;				   /* Handle to this module */

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg)
    {
		case WM_WTSSESSION_CHANGE:
			switch(wParam)
			{
 				case WTS_CONSOLE_CONNECT:
 				case WTS_REMOTE_CONNECT:
				case WTS_SESSION_UNLOCK:
 				case WTS_SESSION_REMOTE_CONTROL:
//? 			case WTS_SESSION_LOGON:
//--!!! 			case WTS_SESSION_LOCK:		// If set this check, active window would be shown on the first desktop
					SendMessage(vwHandle, VW_CHANGEDESK, 1, 0);		// Switch to the first desktop
					break;
				
				case WTS_SESSION_LOCK:	// Minimize all windows on Locking
					if(SendMessage(vwHandle, VW_CURDESK, 0, 0) != 1)	// If it's not first desktop, hide all windows
						PostMessage(FindWindow(_T("Shell_TrayWnd"), NULL), WM_COMMAND, 419, 0);	// It's hack, but working
					break;
			}
			break;
		case MOD_INIT: 
			/* This must be taken care of in order to get the handle to VirtuaWin. */
			/* The handle to VirtuaWin comes in the wParam */
			vwHandle = (HWND) wParam; /* Should be some error handling here if NULL */
			if(!initialised)
			{
				if(!WTSRegisterSessionNotification(g_hWnd, NOTIFY_FOR_THIS_SESSION))
					MessageBox(hwnd, _T("Failed register session notification."), _T("Module Error"), MB_ICONERROR);
				initialised = 1;
			}
			break;
	    
	        
		case MOD_QUIT:
			/* This must be handled, otherwise VirtuaWin can't shut down the module */
			PostQuitMessage(0);
			break;
		case WM_DESTROY:
			WTSUnRegisterSessionNotification(g_hWnd);
			initialised = 0;
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    
    return 0;
}

/*
 * Main startup function
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
    WNDCLASS wc;
    MSG msg;
    
    memset(&wc, 0, sizeof(WNDCLASS));
    wc.style = 0;
    wc.lpfnWndProc = (WNDPROC)MainWndProc;
    wc.hInstance = hInstance ;
    /* IMPORTANT! The class name must be the same as the filename since VirtuaWin uses 
       this for locating the window */
    wc.lpszClassName = _T("VWSwitcher.exe");
  
    if (!RegisterClass(&wc))
        return 0;
  
    /* In this example, the window is never shown */
	g_hWnd = CreateWindow(_T("VWSwitcher.exe"), 
                     _T("VWSwitcher"), 
                     WS_POPUP,
                     CW_USEDEFAULT, 
                     0, 
                     CW_USEDEFAULT, 
                     0,
                     NULL,
                     NULL,
                     hInstance,
					 NULL);
	  if(!g_hWnd)
        return 0;
    
    /* main message loop */
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return (int)msg.wParam;
}
